
#include "..\include\server.h"
#include "..\include\child.h"

//---------------------------------------------------------------------
// the webserver main loop
//---------------------------------------------------------------------
void run_server() {

	static struct sockaddr_in cli_addr;  // static = initialised to zeros
	static struct sockaddr_in serv_addr; // static = initialised to zeros
	int listenfd, socketfd, k;
	u32 ip, length;
		
	u8 *oct = (u8 *)&ip; // alias :)

	DIR_ITER* dir;
	
	printf("Trying to access SD card\n");
	if(NULL == (dir = diropen("fat0:/wiibsrv/htdocs/"))) {
		printf("ARGGG: unable to list files");
	} else {
		dirclose(dir);
	}
	
	// try to setup network three times
	for(k=0; k<3; k++) {
	
		printf("Trying to start nweb (try #%d)\n", k);
		
		// TODO: add protection to avoid deadlock
		while(net_init() == -EAGAIN);

		/* setup the network socket */
		printf("Calling socket()\n");
		if((listenfd = net_socket(AF_INET, SOCK_STREAM,0)) < 0) {
			printf("ARGGG: socket() failed\n");
			continue;
		}

		serv_addr.sin_family = AF_INET;
		serv_addr.sin_port = htons(TCP_PORT);
		serv_addr.sin_addr.s_addr = net_gethostip();
		serv_addr.sin_len = 8;

		printf("Calling bind()\n");
		if(net_bind(listenfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) {
			printf("ARGGG: bind() failed\n");
			continue;
		}
	  
		printf("Calling listen()\n");
		if(net_listen(listenfd, 3) < 0) {
			printf("ARGGG: listen() failed\n");
			continue;
		}
		
		break;
	}
	
	if(listenfd < 0) {
		printf("ARGGG: failed to init socket on time, aborting :'(\n");
		return;
	}
 
	// listen for incoming connections
	ip = net_gethostip();
	printf("Listening on socket %d\n", listenfd);
	printf("Your Wii's ip address is %d.%d.%d.%d\n", oct[0], oct[1], oct[2], oct[3]);
 
	while(1) {
		length = sizeof(cli_addr);
		printf("Calling accept()\n");
		
		if((socketfd = net_accept(listenfd, (struct sockaddr *)&cli_addr, &length)) < 0) {
			printf("ARGGG: accept() failed\n");
			
		} else {
		
			printf("-> incoming connection from %d.%d.%d.%d\n",
				(cli_addr.sin_addr.s_addr >> 24) & 0xFF,
				(cli_addr.sin_addr.s_addr >> 16) & 0xFF,
				(cli_addr.sin_addr.s_addr >> 8) & 0xFF,
				(cli_addr.sin_addr.s_addr) & 0xFF
			);
			
			process_request((void*)socketfd);
			
		}
	}
	
	// never reached :-O
	(void)net_close(listenfd);
	return;
}

